backend/urls.py
from django.urls import path
from backend import views

app_name = 'backend'

urlpatterns = [
    path('accounts/signup/', views.signup, name='signup'),
    path('accounts/signup/check/', views.signup_check, name='signup_check'),
    path('accounts/login/', views.login, name='login'),
    path('accounts/login/identify/', views.identify, name='identify'),
    path('accounts/logout/', views.logout, name='logout'),
    path('accounts/verify/', views.verify, name='verify'),
    path('accounts/verify/resend', views.verify_resend, name='verify_resend'),
    path('accounts/recovery/', views.recovery, name='recovery'),
    path('accounts/edit/', views.edit, name='edit'),

    path('interactions/follow/<int:pk>/', views.follow, name='follow'),
    path('interactions/unfollow/<int:pk>/', views.unfollow, name='unfollow'),

    path('interactions/up-vote/<int:pk>/', views.up_vote, name='up_vote'),
    path('interactions/down-vote/<int:pk>/', views.down_vote, name='down_vote'),

    path('thread/<slug>/', views.thread, name='thread'),
    path('thread/<int:pk>/edit/', views.thread_edit, name='thread_edit'),
    path('thread/<int:pk>/delete/', views.thread_delete, name='thread_delete'),
    path('thread/<int:pk>/reply/', views.thread_reply, name='thread_reply'),

    path('report/', views.report, name='report'),
    path('report/<int:pk>/edit', views.report_edit, name='report_edit'),

    path('observation/<int:pk>/reply', views.observation_reply, name='observation_reply'),
    path('observation/names/', views.observation_names, name='observation_names'),

    path('maps/', views.maps, name='maps'),
    path('search/', views.search, name='search'),
    path('language/<code>/', views.language, name='language'),

    path('mail-test/', views.mail_test, name='mail-test'),
]

config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.views.static import serve

urlpatterns = [
    path('', include('frontend.urls')),
    path('api/', include('backend.urls')),
    path('admin/', admin.site.urls),
    path('_nested_admin/', include('nested_admin.urls')),
]

handler404 = 'frontend.views.handler404'
handler500 = 'frontend.views.handler500'

if not settings.DEBUG:
    # static use white noise
    urlpatterns += path('media/<path:path>/', serve, {'document_root': settings.MEDIA_ROOT}),
else:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

frontend/urls.py
from django.urls import path
from django.views import defaults
from frontend import views

app_name = 'frontend'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about'),
    path('team/', views.team, name='team'),
    path('guidelines/', views.guidelines, name='guidelines'),
    path('elasmoid/', views.elasmoid, name='elasmoid'),
    path('iecsn/', views.iecsn, name='iecsn'),
    path('maps/', views.maps, name='maps'),
    path('articles/', views.articles, name='articles'),
    path('articles/<int:pk>/', views.article, name='article'),
    path('report/', views.report, name='report'),
    path('report/tna/', views.report_tna, name='report_tna'),
    path('search/', views.search, name='search'),
    path('s/<slug>/', views.static, name='static'),

    path('signup/', views.signup, name='signup'),
    path('login/', views.login, name='login'),
    path('login/identify/', views.identify, name='identify'),
    path('recovery/', views.recovery, name='recovery'),
    path('verify/', views.verify, name='verify'),

    path('contributor/observations/', views.contributor_observations, name='contributor_observations'),
    path('contributor/observation/<int:pk>/', views.contributor_observation, name='contributor_observation'),
    path('contributor/leaderboard/', views.contributor_leaderboard, name='contributor_leaderboard'),
    path('contributor/profile/', views.contributor_profile, name='contributor_profile'),
    path('contributor/profile/edit/', views.contributor_profile_edit, name='contributor_profile_edit'),
    path('contributor/profile/<username>/', views.contributor_profile_user, name='contributor_profile_user'),

    path('forum/topics/', views.forum_topics, name='forum_topics'),
    path('forum/thread/<int:pk>/', views.forum_thread, name='forum_thread'),
    path('forum/thread/<int:pk>/edit/', views.forum_thread_edit, name='forum_thread_edit'),
    path('forum/threads/<slug>/', views.forum_threads, name='forum_threads'),
    path('forum/threads/<slug>/create', views.forum_thread_create, name='forum_thread_create'),

    path('form/report', views.form_report, name='form_report'),
    path('form/report/<int:pk>/edit', views.form_report_edit, name='form_report_edit'),
]

frontend/models.py
from django.db import models

# Create your models here.

frontend/views.py
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator
from django.db.models import F, Q, Case, Value, When
from django.http import Http404
from django.shortcuts import render, redirect
from urllib.parse import unquote

from backend.models import (
    Observation,
    ObservationImage,
    ObservationReply,
    User,
    UserConnection,
    Topic,
    Thread,
    ThreadReply,
    ThreadVote,
    Article,
    Page,
    Section,
    SectionImage,
    Navigation,
    SubNavigation,
)
from frontend import utils

def static(request, slug):
    lang = utils.get_session_lang(request)    
    template_name = f'{lang}/pages/static/base.html'
    
    pages = Page.objects.filter(slug=slug)

    if not pages.exists():
        raise Http404()
    
    page = pages.first()
    preview = request.GET.get('preview', False)
    
    if not preview and not page.visibility:
        raise Http404()

    mapper = list()
    sections = Section.objects.filter(level=pages.first()).order_by('order')
    for section in sections:
        section_images = SectionImage.objects.filter(level=section).order_by('pk')
        mapper.append((section, section_images))

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'mapper': mapper,
    }

    return render(request, template_name, response)

def home(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/home.html'

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 1,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def about(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/about.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def team(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/team.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def iecsn(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/iecsn.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 2
    }
    return render(request, template_name, response)


def guidelines(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/guidelines.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def elasmoid(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/elasmoid.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 3
    }
    return render(request, template_name, response)


def report(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def report_tna(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/report-tna.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


@login_required
def form_report(request):
    lang = utils.get_session_lang(request)
    user = User.objects.get(username=request.user.username)
    page = 'report.html' if user.is_verified else 'verify.html'
    template_name = f'{lang}/forms/{page}'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 4
    }
    return render(request, template_name, response)


def maps(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/maps.html'

    gallery = ObservationImage.objects.filter(observation__status='VERIFIED').order_by('-pk')[:6]
    years = [date.year for date in Observation.objects.dates('datetime', 'year')]

    observations = Observation.objects.filter(status='VERIFIED')
    encounter_count = observations.count()
    province_count = observations.values_list('province', flat=True).distinct().count()
    species_count = observations.values_list('scientific_name', flat=True).distinct().count()

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 5,
        'gallery': gallery,
        'years': years,
        'encounter_count': encounter_count,
        'province_count': province_count,
        'species_count': species_count,
    }
    return render(request, template_name, response)


def articles(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/articles.html'

    articles = Article.objects.all().order_by('-created_at')
    
    tag = request.GET.get('tag')
    if tag:
        q_objects = Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)
        articles = articles.filter(q_objects).distinct()

    paginator = Paginator(articles, 12)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'tag': tag,
        'paginator_object': paginator_object,
        'page_range': page_range,
    }

    return render(request, template_name, response)


def article(request, pk):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/article.html'
    article = Article.objects.get(pk=pk)
    article_tags = utils.get_article_tags(article, lang)
    article_url =  "{0}://{1}{2}".format(request.scheme, request.get_host(), request.path)

    q_objects = Q()
    for tag in article_tags:
        q_objects |= Q(articletag__en_tag__icontains=tag) if lang == 'en' else Q(articletag__id_tag__icontains=tag)

    related_articles = Article.objects.all().filter(q_objects).exclude(pk=pk).distinct().order_by('-created_at')[:3]
    
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'page': 6,
        'article': article,
        'article_url': article_url,
        'related_articles': related_articles,
    }

    return render(request, template_name, response)


def identify(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/identify.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def recovery(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/recovery.html'
    token = request.GET.get('token', None)
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'token': token
    }
    return render(request, template_name, response)


def login(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/login.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def signup(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/forms/signup.html'
    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
    }
    return render(request, template_name, response)


def search(request):
    lang = utils.get_session_lang(request)
    template_name = f'{lang}/pages/search.html'

    observations = Observation.objects.filter(status='VERIFIED').order_by('-created_at')
    observation_images = ObservationImage.objects.all()

    category_shark = observations.filter(category='shark').count()
    category_ray = observations.filter(category='ray').count()
    category_chimaera = observations.filter(category='chimaera').count()

    queries = request.GET.get('query', None)

    if queries:
        queries = unquote(queries)
        for query in queries.split():
            observations = observations.filter(
                Q(common_name__icontains=query) |
                Q(scientific_name__icontains=query) |
                Q(location__icontains=query) |
                Q(province__icontains=query) |
                Q(reporter__first_name__icontains=query) |
                Q(reporter__last_name__icontains=query) |
                Q(submitter__icontains=query)
            )

    category = request.GET.get('category', None)
    if category:
        observations = observations.filter(category=category)

    mapper = list()
    for observation in observations:
        observation_image = None
        images = observation_images.filter(observation=observation)
        if images.exists():
            observation_image = images.first()

        mapper.append((observation, observation_image))

    paginator = Paginator(mapper, 5)
    page_number = request.GET.get('page', 1)
    paginator_object = paginator.get_page(page_number)
    page_range = paginator.get_elided_page_range(number=page_number)

    response = {
        'use_navbar': True,
        'navigation': get_navigation(),
        'query': queries,
        'category': category,

frontend/templates/id/forms/identify.html
{% extends 'id/id_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <div class="text-center mb-5">
                    <img class="img-fluid mb-2" src="{% static 'images/common/logos/logo-blue.png' %}" width="100"/>
                    <div class="h3 c-blue">
                        Cari Akun
                    </div>
                </div>
                <form action="{% url 'backend:identify' %}" method="post">
                    {% csrf_token %}
                    <div class="row g-3">
                        <div class="col-md-12">
                            <label for="email" class="form-label">
                                Email <span class="c-red">*</span>
                            </label>
                            <input type="email" class="form-control" name="email" id="email" required>
                        </div>
                        <div class="col-md-12 text-center mt-5">
                            <button id="submit" type="submit" class="btn btn-primary">
                                Submit
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script type="text/javascript">

    </script>
{% endblock %}

frontend/templates/id/forms/login.html
{% extends 'id/id_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <div class="text-center mb-5">
                    <img class="img-fluid mb-2" src="{% static 'images/common/logos/logo-blue.png' %}" width="100"/>
                    <div class="h3 c-blue">
                        Masuk ke Elasmobranch Project Indonesia
                    </div>
                </div>
                <form action="{% url 'backend:login' %}" method="post">
                    {% csrf_token %}
                    <div class="row g-3">
                        <div class="col-md-12">
                            <label for="username" class="form-label">
                                Username <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="username" id="username" required>
                        </div>
                        <div class="col-md-12">
                            <label for="password" class="form-label">
                                Kata Sandi <span class="c-red">*</span>
                            </label>
                            <div class="input-group mb-3">
                                <input type="password" class="form-control" name="password" id="password" required>
                                <span id="password_icon" class="input-group-text">
                                    <i class="bi bi-eye"></i>
                                </span>
                            </div>
                        </div>
                        <div class="col-md-12 text-center mt-5">
                            <button type="submit" class="btn btn-primary">Masuk</button>
                        </div>
                        <div class="col-md-12 text-center">
                            <a class="c-lightblue-2 fw-600 no-link" href="{% url 'frontend:identify' %}">
                                Lupa Kata Sandi?
                            </a>
                        </div>
                        <hr/>
                        <div class="col-md-12 text-center">
                            <a class="btn btn-success" href="{% url 'frontend:signup' %}">
                                Buat Akun Baru
                            </a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script type="text/javascript">
        $(document).ready(function () {
            let passwordIcon = $('#password_icon');
            passwordIcon.click(function () {
                let inputPassword = $(this).siblings().first();
                let inputPasswordType = inputPassword.attr('type');

                if (inputPasswordType === 'text') {
                    inputPassword.attr('type', 'password');
                    $(":first-child", $(this)).removeClass('bi-eye-slash').addClass('bi-eye');
                } else {
                    inputPassword.attr('type', 'text');
                    $(":first-child", $(this)).removeClass('bi-eye').addClass('bi-eye-slash');
                }
            });
        });
    </script>
{% endblock %}

frontend/templates/id/forms/signup.html
{% extends 'id/id_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <div class="text-center mb-5">
                    <img class="img-fluid mb-2" src="{% static 'images/common/logos/logo-blue.png' %}" width="100"/>
                    <div class="h3 c-blue">
                        Gabung bersama 200+ kontributor citizen science
                    </div>
                </div>
                <form action="{% url 'backend:signup' %}" method="post">
                    {% csrf_token %}
                    <div class="row g-3">
                        <div class="col-md-12">
                            <label for="username" class="form-label">
                                Username <span class="c-red">*</span>
                            </label>
                            <div class="input-group">
                                <input type="text" class="form-control" name="username" id="username" required>
                                <div id="usernameFeedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label for="first_name" class="form-label">
                                Nama Depan <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="first_name" id="first_name" required>
                        </div>
                        <div class="col-md-6">
                            <label for="last_name" class="form-label">
                                Nama Belakang <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="last_name" id="last_name" required>
                        </div>
                        <div class="col-md-12">
                            <label for="job" class="form-label">
                                Pekerjaan <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="job" id="job" required>
                        </div>
                        <div class="col-md-6">
                            <label for="phone" class="form-label">
                                No Telepon <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="phone" id="phone" required>
                        </div>
                        <div class="col-md-6">
                            <label for="age" class="form-label">
                                Tanggal Lahir <span class="c-red">*</span>
                            </label>
                            <input type="date" class="form-control" name="birthday" id="birthday" required>
                        </div>
                        <div class="col-md-12">
                            <label for="email" class="form-label">
                                Email <span class="c-red">*</span>
                            </label>
                            <input type="email" class="form-control" name="email" id="email" required>
                        </div>
                        <div class="col-md-12">
                            <label for="email" class="form-label">
                                Bahasa <span class="c-red">*</span>
                            </label>
                            <select class="form-select" name="language" id="language">
                                <option value="en">English</option>
                                <option value="id">Bahasa Indonesia</option>
                            </select>
                        </div>
                        <div class="col-md-12">
                            <label for="password" class="form-label">
                                Kata Sandi <span class="c-red">*</span>
                            </label>
                            <div class="input-group mb-3">
                                <input type="password" class="form-control" name="password" id="password" required>
                                <span id="password_icon" class="input-group-text">
                                    <i class="bi bi-eye"></i>
                                </span>
                                <div id="password_feedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <label for="password" class="form-label">
                                Konfirmasi Kata Sandi <span class="c-red">*</span>
                            </label>
                            <div class="input-group mb-3">
                                <input type="password" class="form-control" name="confirm_password"
                                       id="confirm_password" required>
                                <span id="confirm_password_icon" class="input-group-text">
                                    <i class="bi bi-eye"></i>
                                </span>
                                <div id="confirm_password_feedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-12">
                            <div class="form-check">
                                <input class="form-check-input" type="checkbox" name="check" id="check">
                                <label class="form-check-label" for="check">
                                    Saya setuju dengan
                                    <a class="c-lightblue-2 no-link fw-600" target="_blank"
                                       href="{% url 'frontend:report_tna' %}">
                                        Syarat dan Persetujuan
                                    </a>
                                </label>
                            </div>
                        </div>
                        <div class="col-md-12 text-center mt-5">
                            <button id="submit" type="submit" class="btn btn-primary" disabled>Daftar</button>
                        </div>
                        <div class="col-md-12 text-center">
                            Sudah menjadi kontributor?
                            <a class="c-lightblue-2 no-link fw-600" href="{% url 'frontend:login' %}">Masuk</a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script type="text/javascript">
        $(document).ready(function () {
            let username = $('#username');
            let usernameFeedback = $('#usernameFeedback');

            let password = $('#password');
            let passwordFeedback = $('#password_feedback');
            let confirmPassword = $('#confirm_password');
            let confirmPasswordFeedback = $('#confirm_password_feedback');

            let check = $('#check');
            let submit = $('#submit');

            username.keyup(function (e) {
                let value = e.target.value;
                checkAvailability({'username': value});
            });

            function checkAvailability(params) {
                $.ajax({
                    url: "/api/accounts/signup/check",
                    data: params,
                    type: 'get',
                    dataType: 'json',
                    success: function (data) {
                        let status = data['is_available'];
                        if (status) {
                            feedbackSuccess(username, usernameFeedback, 'Username tersedia');
                        } else {
                            feedbackError(username, usernameFeedback, 'Username tidak valid');
                        }
                    }
                });
            }

            function checkPassword(str) {
                let re = /^(?=.*[A-Z])(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{8,}$/;
                return re.test(str);
            }

            function feedbackSuccess(element, elementFeedback, text) {
                element.removeClass('bd-red').addClass('bd-green');
                element.removeClass('is-invalid').addClass('is-valid');
                elementFeedback.removeClass('c-red').addClass('c-green');
                elementFeedback.text(text);
            }

            function feedbackError(element, elementFeedback, text) {
                element.removeClass('bd-green').addClass('bd-red');
                element.removeClass('is-valid').addClass('is-invalid');
                elementFeedback.removeClass('c-green').addClass('c-red');
                elementFeedback.text(text);
            }

            let passwords = $('#password,#confirm_password');
            passwords.keyup(function () {
                let passwordVal = password.val();
                let confirmPasswordVal = confirmPassword.val();
                let match = passwordVal === confirmPasswordVal;
                let valid = checkPassword(passwordVal);

                if (!valid) {
                    feedbackError(password, passwordFeedback, 'Harus minimal 8 karakter, 1 huruf besar, dan 1 karakter khusus');
                } else {
                    feedbackSuccess(password, passwordFeedback, '')
                }

                if (!match || confirmPasswordVal.length === 0) {
                    feedbackError(confirmPassword, confirmPasswordFeedback, 'Password tidak valid');
                } else {
                    feedbackSuccess(confirmPassword, confirmPasswordFeedback, '')
                }
            })

            check.change(function (e) {
                let checked = e.target.checked;
                if (checked) {
                    submit.removeAttr('disabled');
                } else {
                    submit.attr('disabled', true);
                }
            })


            let passwordIcon = $('#password_icon,#confirm_password_icon');
            passwordIcon.click(function () {
                let inputPassword = $(this).siblings().first();
                let inputPasswordType = inputPassword.attr('type');

                if (inputPasswordType === 'text') {
                    inputPassword.attr('type', 'password');
                    $(":first-child", $(this)).removeClass('bi-eye-slash').addClass('bi-eye');
                } else {
                    inputPassword.attr('type', 'text');
                    $(":first-child", $(this)).removeClass('bi-eye').addClass('bi-eye-slash');
                }
            });
        });
    </script>
{% endblock %}